Files
grpc/test/csharp/codegen/csharp_codegen_base_namespace_test.sh
David Sanderson 717c0fae4b Fix grpc_proto_plugin() genrule warnings (#39060) (#39165)
We here address the following warnings:

    WARNING: /Users/dws/src/grpc-dws/src/compiler/BUILD:87:18: target 'grpc_cpp_plugin' is both a rule and a file; please choose another name for the rule
    WARNING: /Users/dws/src/grpc-dws/src/compiler/BUILD:93:18: target 'grpc_csharp_plugin' is both a rule and a file; please choose another name for the rule
    WARNING: /Users/dws/src/grpc-dws/src/compiler/BUILD:99:18: target 'grpc_node_plugin' is both a rule and a file; please choose another name for the rule
    WARNING: /Users/dws/src/grpc-dws/src/compiler/BUILD:105:18: target 'grpc_objective_c_plugin' is both a rule and a file; please choose another name for the rule
    WARNING: /Users/dws/src/grpc-dws/src/compiler/BUILD:111:18: target 'grpc_php_plugin' is both a rule and a file; please choose another name for the rule
    WARNING: /Users/dws/src/grpc-dws/src/compiler/BUILD:117:18: target 'grpc_python_plugin' is both a rule and a file; please choose another name for the rule
    WARNING: /Users/dws/src/grpc-dws/src/compiler/BUILD:123:18: target 'grpc_ruby_plugin' is both a rule and a file; please choose another name for the rule

that come from asking Bazel to build the following:

    @com_github_grpc_grpc//src/compiler:grpc_cpp_plugin
    @com_github_grpc_grpc//src/compiler:grpc_csharp_plugin
    @com_github_grpc_grpc//src/compiler:grpc_node_plugin
    @com_github_grpc_grpc//src/compiler:grpc_objective_c_plugin
    @com_github_grpc_grpc//src/compiler:grpc_php_plugin
    @com_github_grpc_grpc//src/compiler:grpc_python_plugin
    @com_github_grpc_grpc//src/compiler:grpc_ruby_plugin

The macro grpc_proto_plugin() in bazel/grpc_build_system.bzl has a genrule that uses the same name for both the rule and its output file.  This macro gets used in src/compiler/BUILD to define the above plugin targets.

We address this by giving the rule's output file a different name from the rule.  This avoids needing to update all the existing references to the plugin rules.

Closes #39060

Closes #39165

PiperOrigin-RevId: 766690690
2025-06-03 09:12:26 -07:00

146 lines
4.9 KiB
Bash
Executable File

#!/bin/bash
# Copyright 2023 gRPC authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# Run this script via bazel test
# It expects that protoc and grpc_csharp_plugin have already been built.
# Simple test - compare generated output to expected files
# shellcheck disable=SC1090
set -x
TESTNAME=basenamespace
# --- begin runfiles.bash initialization v3 ---
# Copy-pasted from the Bazel Bash runfiles library v3.
set -uo pipefail; set +e; f=bazel_tools/tools/bash/runfiles/runfiles.bash
source "${RUNFILES_DIR:-/dev/null}/$f" 2>/dev/null || \
source "$(grep -sm1 "^$f " "${RUNFILES_MANIFEST_FILE:-/dev/null}" | cut -f2- -d' ')" 2>/dev/null || \
source "$0.runfiles/$f" 2>/dev/null || \
source "$(grep -sm1 "^$f " "$0.runfiles_manifest" | cut -f2- -d' ')" 2>/dev/null || \
source "$(grep -sm1 "^$f " "$0.exe.runfiles_manifest" | cut -f2- -d' ')" 2>/dev/null || \
{ echo>&2 "ERROR: cannot find $f"; exit 1; }; f=; set -e
# --- end runfiles.bash initialization v3 ---
# protoc and grpc_csharp_plugin binaries are supplied as "data" in bazel
PROTOC=$(rlocation "$RLOCATIONPATH_PROTOC")
PLUGIN=$(rlocation "$RLOCATIONPATH_PLUGIN")
# where to find the test data
DATA_DIR=./test/csharp/codegen/${TESTNAME}
# output directory for the generated files
PROTO_OUT=./proto_out
rm -rf ${PROTO_OUT}
mkdir -p ${PROTO_OUT}
# run protoc and the plugin specifying the base_namespace options
$PROTOC \
--plugin=protoc-gen-grpc-csharp="$PLUGIN" \
--csharp_out=${PROTO_OUT} \
--grpc-csharp_out=${PROTO_OUT} \
--csharp_opt=base_namespace=Example \
--grpc-csharp_opt=base_namespace=Example \
-I ${DATA_DIR}/proto \
${DATA_DIR}/proto/namespacetest.proto
# log the files generated
ls -lR ./proto_out
# Verify the output files exist in the right location.
# The base_namespace option does not change the generated code just
# the location of the files. Contents are not checked in this test.
# The C# namespace option in the proto file of "Example.V1.CodegenTest"
# combined with the command line options above should mean the generated files
# are created in the output directory "V1/CodegenTest"
# First file is generated by protoc.
[ -e ${PROTO_OUT}/V1/CodegenTest/Namespacetest.cs ] || {
echo >&2 "missing generated output, expecting V1/CodegenTest/Namespacetest.cs"
exit 1
}
# Second file is generated by the plugin.
[ -e ${PROTO_OUT}/V1/CodegenTest/NamespacetestGrpc.cs ] || {
echo >&2 "missing generated output, expecting V1/CodegenTest/NamespacetestGrpc.cs"
exit 1
}
# Run again with base_namespace option set to empty value to check that the files
# are created under a full directory structure defined by the namespace
rm -rf ${PROTO_OUT}
mkdir -p ${PROTO_OUT}
$PROTOC \
--plugin=protoc-gen-grpc-csharp="$PLUGIN" \
--csharp_out=${PROTO_OUT} \
--grpc-csharp_out=${PROTO_OUT} \
--csharp_opt=base_namespace= \
--grpc-csharp_opt=base_namespace= \
-I ${DATA_DIR}/proto \
${DATA_DIR}/proto/namespacetest.proto
# log the files generated
ls -lR ./proto_out
# Verify the output files exist in the right location.
# The C# namespace option in the proto file of "Example.V1.CodegenTest"
# combined with the command line options above should mean the generated files
# are created in the output directory "Example/V1/CodegenTest"
# First file is generated by protoc.
[ -e ${PROTO_OUT}/Example/V1/CodegenTest/Namespacetest.cs ] || {
echo >&2 "missing generated output, expecting Example/V1/CodegenTest/Namespacetest.cs"
exit 1
}
# Second file is generated by the plugin.
[ -e ${PROTO_OUT}/Example/V1/CodegenTest/NamespacetestGrpc.cs ] || {
echo >&2 "missing generated output, expecting Example/V1/CodegenTest/NamespacetestGrpc.cs"
exit 1
}
# Run again without the base_namespace options to check the files are created
# in the root of the output directory
rm -rf ${PROTO_OUT}
mkdir -p ${PROTO_OUT}
$PROTOC \
--plugin=protoc-gen-grpc-csharp="$PLUGIN" \
--csharp_out=${PROTO_OUT} \
--grpc-csharp_out=${PROTO_OUT} \
-I ${DATA_DIR}/proto \
${DATA_DIR}/proto/namespacetest.proto
ls -lR ./proto_out
[ -e ${PROTO_OUT}/Namespacetest.cs ] || {
echo >&2 "missing generated output, expecting Namespacetest.cs"
exit 1
}
[ -e ${PROTO_OUT}/NamespacetestGrpc.cs ] || {
echo >&2 "missing generated output, expecting NamespacetestGrpc.cs"
exit 1
}
# Run one extra command to clear $? before exiting the script to prevent
# failing even when tests pass.
echo "Plugin test: ${TESTNAME}: passed."